
q := NameToIndet("q");

GCD := function( f, m )
    local i;
    if f = q then
        return NameToIndet([m,0]);
    else
        i := CoefficientsOfUnivariatePolynomial(f-q)[1];
        return NameToIndet([m,-i]);
    fi;
end;

WP := [];
WP[1] := [];
WP[2] := [];
WP[3] := [1];
WP[4] := [2,4,6];

WP[5] := [2,6,22,57];
WP[5][5] := 3*q+2*GCD(q,2)+GCD(q,3)+2*GCD(q-1,3)+GCD(q-1,4)+63;

ReadPackage("porc", "lib/wedge6.gi");
ReadPackage("porc", "lib/wedge7.gi");

WP := WP*q^0;

PorcPolyForLieAlgebras := function( d, k )
    local l, f;

    # these cases do not exist
    if not IsInt(d) or d <= 1 then return fail; fi;

    # this case is not implemented
    if d > 7 then return fail; fi;

    # these cases do not exist
    if not IsInt(k) or k <= 0 then return fail; fi;

    # catch some trivial cases
    l := d*(d-1)/2;
    if k = l then return 1 * q^0; fi;
    if k > l then return 0 * q^0; fi;
    if k > l/2 then k := l-k; fi;

    # read off
    return WP[d][k];
end;

AllPorcPolysForLieAlgebras := function( d )
    local l;
    l := d*(d-1)/2-1;
    if IsInt(l/2) then l := l/2; else l := (l+1)/2; fi;
    return List([1..l], x -> PorcPolyForLieAlgebras( d, x ));
end;

PP := [];
PP[1] := [];
PP[2] := [3];
PP[3] := [4, q-GCD(q-0,2)+15, 3*q-3*GCD(q-0,2)+30 ];
PP[4] := [ 6, 4*q-2*GCD(q-0,2)+50 ];
PP[4][3] := 
  q^5+2*q^4+7*q^3-q^2*GCD(q-0,2)+26*q^2-10*q*GCD(q-0,2)+q*GCD(q-1,3)
  +98*q-37*GCD(q-0,2)-1/2*GCD(q-0,3)+4*GCD(q-1,3)+GCD(q-1,4)+615/2;
PP[4][4] := 
  q^8+2*q^7+5*q^6+10*q^5+24*q^4-3*q^3*GCD(q-0,2)+56*q^3-15*q^2*GCD(q-0,2)
  +q^2*GCD(q-1,3)+153*q^2-52*q*GCD(q-0,2)+6*q*GCD(q-1,3)+2*q*GCD(q-1,4)
  -9/4*GCD(q-0,2)*GCD(q-1,3)-1/4*GCD(q-0,2)*GCD(q-2,3)+375*q-121*GCD(q-0,2)
  -15/8*GCD(q-0,3)+171/8*GCD(q-1,3)+3/8*GCD(q-2,3)+6*GCD(q-1,4)
  -1/4*GCD(q-0,5)+GCD(q-1,5)+6565/8;
PP[4][5] := 
  q^9+2*q^8+5*q^7+10*q^6+21*q^5-q^4*GCD(q-0,2)+45*q^4-8*q^3*GCD(q-0,2)
  +102*q^3-26*q^2*GCD(q-0,2)+2*q^2*GCD(q-1,3)+q^2*GCD(q-1,4)+242*q^2
  -81*q*GCD(q-0,2)+10*q*GCD(q-1,3)+4*q*GCD(q-1,4)-1/4*q*GCD(q-0,5)
  -4*GCD(q-0,2)*GCD(q-1,3)+2221/4*q-167*GCD(q-0,2)-GCD(q-0,3)+36*GCD(q-1,3)
  +12*GCD(q-1,4)-1/4*GCD(q-0,5)+2*GCD(q-1,5)+4353/4;

ReadPackage("porc", "lib/group5.gi");
ReadPackage("porc", "lib/group6.gi");
ReadPackage("porc", "lib/group7.gi");
PP := PP*q^0;

PorcPolyForGroups := function( d, k )
    local l, f;

    # these cases do not exist
    if not IsInt(d) or d < 1 then return fail; fi;

    # this case is not implemented
    if d > 7 then return fail; fi;

    # these cases do not exist
    if not IsInt(k) or k <= 0 then return fail; fi;

    # catch some trivial cases
    l := d*(d+1)/2;
    if k = l then return 1 * q^0; fi;
    if k > l then return 0 * q^0; fi;
    if k > l/2 then k := l-k; fi;

    # read off
    return PP[d][k];
end;

AllPorcPolysForGroups := function( d )
    local l;
    l := d*(d+1)/2-1;
    if IsInt(l/2) then l := l/2; else l := (l+1)/2; fi;
    return List([1..l], x -> PorcPolyForGroups( d, x ));
end;

